# Generated by cloudcoil-model-codegen v0.1.1
# DO NOT EDIT

from __future__ import annotations

from typing import Annotated, Callable, Literal, Optional, Type, Union

from pydantic import Field

from cloudcoil import apimachinery
from cloudcoil.pydantic import BaseBuilder, BaseModel, ListBuilder, Self
from cloudcoil.resources import Resource, ResourceList

from ..core import v1


class EventSeries(BaseModel):
    class Builder(BaseBuilder):
        def build(self) -> "EventSeries":
            return EventSeries(**self._attrs)

        def count(self, value: int) -> Self:
            return self._set("count", value)

        def last_observed_time(
            self,
            value_or_callback: Union[
                apimachinery.MicroTime,
                Callable[[Type[apimachinery.MicroTime]], apimachinery.MicroTime],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(apimachinery.MicroTime)
            return self._set("last_observed_time", value)

    @classmethod
    def builder(cls) -> Builder:
        return cls.Builder()

    @classmethod
    def list_builder(cls) -> ListBuilder[Self]:
        return ListBuilder[cls]()  # type: ignore[valid-type]

    count: Annotated[
        int,
        Field(
            description="count is the number of occurrences in this series up to the last heartbeat time."
        ),
    ]
    last_observed_time: Annotated[
        apimachinery.MicroTime,
        Field(
            alias="lastObservedTime",
            description="lastObservedTime is the time when last Event from the series was seen before last heartbeat.",
        ),
    ]


class Event(Resource):
    class Builder(BaseBuilder):
        def build(self) -> "Event":
            return Event(**self._attrs)

        def action(self, value: Optional[str]) -> Self:
            return self._set("action", value)

        def api_version(self, value: Optional[Literal["events.k8s.io/v1"]]) -> Self:
            return self._set("api_version", value)

        def deprecated_count(self, value: Optional[int]) -> Self:
            return self._set("deprecated_count", value)

        def deprecated_first_timestamp(
            self,
            value_or_callback: Union[
                Optional[apimachinery.Time],
                Callable[[Type[apimachinery.Time]], apimachinery.Time],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(apimachinery.Time)
            return self._set("deprecated_first_timestamp", value)

        def deprecated_last_timestamp(
            self,
            value_or_callback: Union[
                Optional[apimachinery.Time],
                Callable[[Type[apimachinery.Time]], apimachinery.Time],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(apimachinery.Time)
            return self._set("deprecated_last_timestamp", value)

        def deprecated_source(
            self,
            value_or_callback: Union[
                Optional[v1.EventSource],
                Callable[[Type[v1.EventSource]], v1.EventSource],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(v1.EventSource)
            return self._set("deprecated_source", value)

        def event_time(
            self,
            value_or_callback: Union[
                apimachinery.MicroTime,
                Callable[[Type[apimachinery.MicroTime]], apimachinery.MicroTime],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(apimachinery.MicroTime)
            return self._set("event_time", value)

        def kind(self, value: Optional[Literal["Event"]]) -> Self:
            return self._set("kind", value)

        def metadata(
            self,
            value_or_callback: Union[
                Optional[apimachinery.ObjectMeta],
                Callable[[Type[apimachinery.ObjectMeta]], apimachinery.ObjectMeta],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(apimachinery.ObjectMeta)
            return self._set("metadata", value)

        def note(self, value: Optional[str]) -> Self:
            return self._set("note", value)

        def reason(self, value: Optional[str]) -> Self:
            return self._set("reason", value)

        def regarding(
            self,
            value_or_callback: Union[
                Optional[v1.ObjectReference],
                Callable[[Type[v1.ObjectReference]], v1.ObjectReference],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(v1.ObjectReference)
            return self._set("regarding", value)

        def related(
            self,
            value_or_callback: Union[
                Optional[v1.ObjectReference],
                Callable[[Type[v1.ObjectReference]], v1.ObjectReference],
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(v1.ObjectReference)
            return self._set("related", value)

        def reporting_controller(self, value: Optional[str]) -> Self:
            return self._set("reporting_controller", value)

        def reporting_instance(self, value: Optional[str]) -> Self:
            return self._set("reporting_instance", value)

        def series(
            self,
            value_or_callback: Union[
                Optional[EventSeries], Callable[[Type[EventSeries]], EventSeries]
            ],
        ) -> Self:
            value = value_or_callback
            if callable(value_or_callback):
                value = value_or_callback(EventSeries)
            return self._set("series", value)

        def type(self, value: Optional[str]) -> Self:
            return self._set("type", value)

    @classmethod
    def builder(cls) -> Builder:
        return cls.Builder()

    @classmethod
    def list_builder(cls) -> ListBuilder[Self]:
        return ListBuilder[cls]()  # type: ignore[valid-type]

    action: Annotated[
        Optional[str],
        Field(
            description="action is what action was taken/failed regarding to the regarding object. It is machine-readable. This field cannot be empty for new Events and it can have at most 128 characters."
        ),
    ] = None
    api_version: Annotated[
        Optional[Literal["events.k8s.io/v1"]],
        Field(
            alias="apiVersion",
            description="APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources",
        ),
    ] = "events.k8s.io/v1"
    deprecated_count: Annotated[
        Optional[int],
        Field(
            alias="deprecatedCount",
            description="deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type.",
        ),
    ] = None
    deprecated_first_timestamp: Annotated[
        Optional[apimachinery.Time],
        Field(
            alias="deprecatedFirstTimestamp",
            description="deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.",
        ),
    ] = None
    deprecated_last_timestamp: Annotated[
        Optional[apimachinery.Time],
        Field(
            alias="deprecatedLastTimestamp",
            description="deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.",
        ),
    ] = None
    deprecated_source: Annotated[
        Optional[v1.EventSource],
        Field(
            alias="deprecatedSource",
            description="deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type.",
        ),
    ] = None
    event_time: Annotated[
        apimachinery.MicroTime,
        Field(
            alias="eventTime",
            description="eventTime is the time when this Event was first observed. It is required.",
        ),
    ]
    kind: Annotated[
        Optional[Literal["Event"]],
        Field(
            description="Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"
        ),
    ] = "Event"
    metadata: Annotated[
        Optional[apimachinery.ObjectMeta],
        Field(
            description="Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata"
        ),
    ] = None
    note: Annotated[
        Optional[str],
        Field(
            description="note is a human-readable description of the status of this operation. Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB."
        ),
    ] = None
    reason: Annotated[
        Optional[str],
        Field(
            description="reason is why the action was taken. It is human-readable. This field cannot be empty for new Events and it can have at most 128 characters."
        ),
    ] = None
    regarding: Annotated[
        Optional[v1.ObjectReference],
        Field(
            description="regarding contains the object this Event is about. In most cases it's an Object reporting controller implements, e.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object."
        ),
    ] = None
    related: Annotated[
        Optional[v1.ObjectReference],
        Field(
            description="related is the optional secondary object for more complex actions. E.g. when regarding object triggers a creation or deletion of related object."
        ),
    ] = None
    reporting_controller: Annotated[
        Optional[str],
        Field(
            alias="reportingController",
            description="reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events.",
        ),
    ] = None
    reporting_instance: Annotated[
        Optional[str],
        Field(
            alias="reportingInstance",
            description="reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters.",
        ),
    ] = None
    series: Annotated[
        Optional[EventSeries],
        Field(
            description="series is data about the Event series this event represents or nil if it's a singleton Event."
        ),
    ] = None
    type: Annotated[
        Optional[str],
        Field(
            description="type is the type of this event (Normal, Warning), new types could be added in the future. It is machine-readable. This field cannot be empty for new Events."
        ),
    ] = None


EventList = ResourceList["Event"]
